function dr = restore_f0(dd,sr)
% dr = restore_f0(dd,sr)
%   Take a waveform dd at sampling rate sr
%   and restore fundamental by nonlinearity & mixing in with
%   original.
% 2013-02-02 Zhuo Chen, Dan Ellis dpwe@ee.columbia.edu

% low pass filter gently below 1000 Hz removes higher frequencies
[bl,al] = butter(2, [1000/(sr/2)]);
ddl = filter(bl,al,dd);

% square to introduce missing low harmonics
ddl2 = ddl.^2;

% band pass filter to remove dc and leave only the harmonics we want to restore
[bb,ab] = ellip(4,3,40,[100/4000 300/4000]);
dl = filter(bb,ab,ddl2);

% add back into speech with appropriate scaling (?)
%the scalar parameter need to be chosen carefully for BABEL data. 
dr = dl*10 + dd;
